	PAGE	66,132
;
BEUL	EQU	1	;#0 => RESIDENS PROGRAM
maxkar	equ	0c0h	;nagyobb erteku byte-okat plusz hosszjelzessel 
;
COMMENT *

The screen image files are using a compressed format.
The same format is also used by PC-Paintbrush, Ventura Publisher
                                Page Makere, Cameron Handy Painter etc.
    
   Bytes 00 - 03: 0A 05 01 01
   Bytes 04 - 05: Minimum x value (always 0)
   Bytes 06 - 07: Minimum y value (always 0)
   Bytes 08 - 09: Maximum x value (depending of the used graphic) 
   Bytes 0A - 0B: Maximum y value (depending of the used graphic)
   Bytes 0C - 0D: Width of the picture (= 08/09 - 04/05 + 1)
   Bytes 0E - 0F: Hight of the picture (= 0A/0B - 06/07 + 1)
   
   Bytes 10 - 3F: RGB values for all 16 colors
   
   Byte  40     : 00
   Byte  41     : Number of graphic levels (always 1)
   Bytes 42 - 43: Bytes per line (per level, usual 0C/0D devided by 8)
   Bytes 44 - 46: 00 00 00
   Bytes 47 - 48: Number of lines of the graphic card
   
   Bytes 49 - 7F: 00
   
   Starting on byte 80H follow the image data using following format:
   
   If byte # B is >= C0H, than is byte # B+1 a data byte, which is repeated
   (B - C0H) times.
   
   If byte # B is < C0H, than is byte # B itself a data byte.
   
   Example:
   
   C5 3F 4D 58 C1 C3 C7 00
   
   will be translated into:
   
   3F 3F 3F 3F 3F 4D 58 C3 00 00 00 00 00 00 00
;
;
;                         Table of Video Modes                             
;                                                                    Buffer
;  Mode     Type        Resolution      Adapter(s)      Colors       Address 
;  00h     Text          40 x 25      All but MDA       16 gray       B8000
;  01h     Text          40 x 25      All but MDA   16 fore/8 back    B8000
;  02h     Text          80 x 25      All but MDA       16 gray       B8000
;  03h     Text          80 x 25      All but MDA   16 fore/8 back    B8000
;  04h   Graphics       320 x 200     All but MDA         4           B8000
;  05h   Graphics       320 x 200     All but MDA       4 gray        B8000
;  06h   Graphics       640 x 200     All but MDA         2           B8000
;  07h     Text          80 x 25        MDA,EGA          b/w          B0000
;  08h   Graphics       160 x 200        PCjr            16           B0000
;  09h   Graphics       320 x 200        PCjr            16           B0000
;  0Ah   Graphics       640 x 200        PCjr             4           B0000
;  0Bh   Reserved    (internal to EGA)                                     
;  0Ch   Reserved    (internal to EGA)                                     
;  0Dh   Graphics       320 x 200        EGA             16           A0000
;  0Eh   Graphics       640 x 200        EGA             16           A0000
;  0Fh   Graphics       640 x 350        EGA             b/w          A0000
;  10h   Graphics       640 x 350        EGA             16           A0000
;

*
CSEG	SEGMENT
	ASSUME	CS:CSEG,DS:CSEG
;========================================
;========================================
; EQU ERTEKEK
;
; *** GRAFIKUS KEPRNYO JELLEMZOK CGA!!!
GRAF_SOR	EQU	50H	; GRAFIKUS SOR HOSSZA
G_SOR_SZAM	EQU	200	; GRAFIKUS SOROK SZAMA
G_ELTOLAS	EQU	2000H	; SORVALTAS ELTOLASI ERTEKE
D_SEG_G		EQU	0B800H	; GRAFIKUS TERULET SEGMENS CIME
; *** KARAKTERES KEPERNYO JELLEMZOK
KARD_HOSSZ	EQU	4000	; KARAKTERES KEPERNY HOSSZA
D_SEG_K		EQU	0B000H	; KARAKTERES KEPERNYO SEGMENS CIME
; *** INT CIMEK ***
PR_SC_INT	EQU	5	; PRTSC CIME
DISP_HIV	EQU	10h	; DISPLAY BIOS HIVAS
DOS_HIV		EQU	21H	; DOS HIVASOK
uj_dos		equ	dos_hiv
;  0e3h    ; eredeti dos funkcio uj cime
; *** HIVOTT DOS FUNKCIOK ***
ITC_OLVAS	EQU	35H	; IT CIM OLVAS
ITC_IR		EQU	25H	; IT CIM IR
REZIDENS	EQU	31H	; PROGRAM BEULTETES
FILE_MAKE	EQU	3CH	; 
FILE_CLOSE	EQU	3EH
FILE_WRITE	EQU	40H
; *** FILE JELLEMZOK ***
F_ATTRIB	EQU	20H	; ARCHIV FILE
; *** DISPLAY KOD ***
D_TIP_BE	EQU	15	; DISPLAY TIPUS LEKERDEZES
; *** file fej parameterek ***
FEJ_HOSSZ	EQU	5
C_SEG1		EQU	0B800H	;CGA 1.SZEGMENS
C_SEG2		EQU	0BA00H	;CGA 2.SZEGMENS
;
H_SCR0		EQU	0B000H	;HERCULES 0. LAP MEMORIA CIME
H_SCR1		EQU	0B800H	;HERCULES 1. LAP MEMORIA CIME
;==================================================
;##################################################
;### START ES PROGRAM BEULTETES                 ###
;##################################################
	org	100h
START:	jmp	STARTX
;
A4_SOR		EQU	66	; A4 eseten a sorok szama
A4GSOR		EQU	728	; A4 graf. eseten a sorok szama
A4GOSZ		EQU	720	; A4 graf. eseten az oszlopok szama
;
AFLAG	DB	0	;0/1/2/3 DISPLAY MENTES TIPUSA
CFLAG	DB	1	;1 => OUTPUT FILE FOLYTATASRA NYITAS
KFLAG	DB	0	;1 => PROGRAM KILOVES
;
; *** PRTSC REGI CIME ***
;
PSC_MENT_S	DW	0
PSC_MENT_O	DW	0
;
	IF	BEUL	;########
RESI	DW	1
	ELSE		;########
RESI	DW	0
	ENDIF		;########
;
;*** PRTSC IT CIM OLVASASA ES MENTESE
;=========================================
;  VALTOZOK ES ADATOK
RowPuf	DB	320 DUP(0)	;AKTUALIS EGA/HGA/CGA SOR PUFFERE
SPUFF	DB	84 DUP(0)	;AKTUALIS ASCII       SOR PUFFERE
SEGED	DB	700 DUP(0)	;AKTUALIS FILE TARTALOM
; *** HANDLE ***
HERC		DW	0	;0 => NINCS HERCULES KARTYA
H_BASE		DW	H_SCR0	;AKTIV SCREEN MEM. LAPCIM
;
HANDLE		DW	0
;
IMGNB		DW	0	;KEP FILE-OK SZAMA
;
; *** IMPLICIT FILE NEV ***
TXT_NEV	DB	'\TXTSAV.TXT',0
IMG_NEV	DB	'\PCXSAV'
VERZIO	DB	'00.PCX',0
; *** TIPUS BYTE ***
D_TIPUS		DB	0
; *** FILE TIPUS FEJEK ***
;
PCXFEJ	DB	00AH,005H,001H,001H,000H,000H,000H,000H	;00-07
	DB	07FH,002H,05DH,001H,080H,002H,05EH,001H	;08-0F
	DB	000H,000H,000H,000H,000H,0AAH,000H,0AAH	;10-17
	DB	000H,000H,0AAH,0AAH,0AAH,000H,000H,0AAH	;18-1F
	DB	000H,0AAH,0AAH,0AAH,000H,0AAH,0AAH,0AAH	;20-27
	DB	055H,055H,055H,055H,055H,0FFH,055H,0FFH	;28-2F
	DB	055H,055H,0FFH,0FFH,0FFH,055H,055H,0FFH	;30-37
	DB	055H,0FFH,0FFH,0FFH,055H,0FFH,0FFH,0FFH	;38-3F
	DB	000H,004H,050H,000H,000H,000H,05EH,001H	;40-47
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;48-4F
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;50-57
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;58-5F
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;60-67
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;68-6F
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;70-77
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;78-7F
L_PCX	EQU	$-PCXFEJ
;
RGBCGA	DB	000H,000H,000H,0FFH,0FFH,0FFH,000H,0AAH	;10-17
	DB	000H,000H,0AAH,0AAH,0AAH,000H,000H,0AAH	;18-1F
	DB	000H,0AAH,0AAH,0AAH,000H,0AAH,0AAH,0AAH	;20-27
	DB	055H,055H,055H,055H,055H,0FFH,055H,0FFH	;28-2F
	DB	055H,055H,0FFH,0FFH,0FFH,055H,055H,0FFH	;30-37
	DB	055H,0FFH,0FFH,0FFH,055H,0FFH,0FFH,0FFH	;38-3F
;
RGBHGA	DB	000H,001H,000H,0FFH,001H,000H,000H,001H	;10-17
	DB	000H,0FFH,001H,000H,000H,001H,000H,0FFH	;18-1F
	DB	001H,000H,000H,001H,000H,0FFH,001H,000H	;20-27
	DB	000H,001H,000H,0FFH,001H,000H,000H,001H	;28-2F
	DB	000H,0FFH,001H,000H,000H,000H,000H,000H	;30-37
	DB	000H,000H,000H,000H,000H,000H,000H,000H	;38-3F
;
RGBEGA	DB	000H,000H,000H,000H,000H,0AAH,000H,0AAH	;10-17	
	DB	000H,000H,0AAH,0AAH,0AAH,000H,000H,0AAH	;18-1F
	DB	000H,0AAH,0AAH,0AAH,000H,0AAH,0AAH,0AAH	;20-27
	DB	055H,055H,055H,055H,055H,0FFH,055H,0FFH	;28-2F
	DB	055H,055H,0FFH,0FFH,0FFH,055H,055H,0FFH	;30-37
	DB	055H,0FFH,0FFH,0FFH,055H,0FFH,0FFH,0FFH	;38-3F
;
TABLA	LABEL   WORD
	DW	KARAK,0	;0
	DW	KARAK,0	;1
	DW	KARAK,0	;2
	DW	KARAK,0	;3
	DW	GRAPH,1	;4
	DW	GRAPH,1	;5
	DW	GRAPH,1	;6
	DW	ALFAN,0	;7
	DW	HERCMOD,1 ; HERCULES ESETEN
	DW	GRAPH,1	;9	EGA ????
	DW	GRAPH,1	;A
	DW	GRAPH,1	;B
	DW	GRAPH,1	;C
	DW	EGA0D,1	;D
	DW	EGA0E,1	;E
	DW	EGA0F,1	;F
	DW	EGA10,1 ;10
;
; *** eroforras gondok ***
ved_dos		db	0
ved_int5	db	0
bejegyez	db	0
;==========================================
; #########################################
; #### KEPERNYO KIIRO RUTIN ###############
; #### UJ PRTSC FUNKCIO     ###############
; MUKODESE: TAR REZIDENS PROGRAM, AMI
;	    A PRTSC GOMB LENYOMASAVAL
;	    HOZHATO MUKODESBE.
;	    A PROGRAM AZ AKTUALIS KEPERNYO
;	    TARTALMAT EGY PCXSAVXX.PCX NEVU FILE-BA
;	    IRJA.
;##########################################
; *** AZONOSITO AZ UJBOLI TOLTESHEZ
	DW	'Vx'
BEGIN:
	sti
	PUSH	DS
	PUSH	ES
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	BP
	PUSH	SI
	PUSH	DI	 
; *** BEALLITJUK AZ ADAT SEGMENST
	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
; szemafor ellenorzes ***
	CALL	FORUTIN
;
	POP	DI
	POP	SI
	POP	BP
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	POP	ES
	POP	DS
	IRET
;
FORUTIN:
	cmp	byte ptr ved_dos,0
	jz	mehet
	mov	byte ptr bejegyez,1
	jmp	error
mehet:
	cmp	byte ptr ved_int5,0
	jz	MEHETX
	JMP	error
MEHETX:	mov	byte ptr ved_int5,1
; *** LEKERDEZZUK A KEPERNYO TIPUST
	MOV	AH,8
	MOV	AL,BYTE PTR HERC
	OR	AL,AL
	JZ	MEHET0	;NINCS HERCULES KARTYA
	CALL	GETMOD
	OR	AX,AX
	MOV	AH,7	;HERCULES TEXT => 7_ES UZEMMOD
	JZ	MEHET1;ASCII MENTES LESZ
	MOV	AH,8
	MOV	WORD PTR H_BASE,H_SCR1
	CMP	AL,2
	JZ	MEHET1
	MOV	WORD PTR H_BASE,H_SCR0
	JMP	MEHET1	
MEHET0:	MOV	AH,D_TIP_BE
	INT	DISP_HIV
;	AND	AL,0FH
	MOV	AH,AL
MEHET1:	MOV	D_TIPUS,AH
; *** MEG KREALJUK A KEP FILE-T ***
	MOV	AL,D_TIPUS
	XOR	AH,AH
	ADD	AX,AX
	MOV	BX,AX
	ADD	BX,BX
	MOV	AX,tabla[BX+2]
	OR	AX,AX
	JNZ	MEHET2	;GRAFIKUS MOD
;
	MOV	DX,OFFSET TXT_NEV
	MOV	AL,CFLAG
	OR	AL,AL
	JZ	MEHET3	;UJ TXTSAV.TXT-T FILE-T KELL LETREHOZNI
;
	MOV	AH,3DH
	MOV	AL,1	;CSAK IRASRA
	MOV	DX,OFFSET TXT_NEV
	INT	UJ_DOS
	JC	MEHET3		; HIBA ESETEN KREALAS
	MOV 	HANDLE,AX	; FILE SORSZAM MENTESE
	MOV	BX,AX
	MOV	CX,0
	MOV	DX,0
	MOV	AX,4202H	; FILE VEGERE POZIC.
	INT	UJ_DOS		; FILE VEGERE ALLAS
	JMP	SHORT MEHET4
MEHET2:	MOV	DX,OFFSET IMG_NEV
	CMP	BYTE PTR CFLAG,0
	JZ	MEHET3		; IMGSAV00.IMG CREATE
	MOV	AX,IMGNB
	INC	IMGNB
	MOV	SI,OFFSET VERZIO
	CALL	SBYTE
MEHET3:	MOV	AH,FILE_MAKE
	MOV	CX,F_ATTRIB
	INT	UJ_DOS
	JC	ERROR		; HIBA ESETEN VISSZATERES
	MOV 	HANDLE,AX	; FILE SORSZAM MENTESE
; *** KEP KIIRAS TIPUSONKENT ***
MEHET4:	MOV	AL,D_TIPUS
	XOR	AH,AH
	ADD	AX,AX
	MOV	BX,AX
	ADD	BX,BX
	JMP	TABLA[BX]	; ELMEGYUNK A MEGFELELO TIPUSHOZ
; *** LEZARJUK A KEP FILE-T
ZARAS:
	MOV	AH,FILE_CLOSE
	MOV	BX,HANDLE
	INT	UJ_DOS
	mov 	byte ptr ved_int5,0
ERROR:	RET
;
SBYTE:	MOV	AH,AL	;BE:AL=KIIRANDO KARAKTER
	MOV	CL,4	;   2 DB HEXA SZAMJEGY KIIRASA
	SHR	AL,CL
	CALL	STETR
	INC	SI
	MOV	AL,AH
	CALL	STETR
	RET
;
STETR:	AND	AL,0FH	;BE:AL=KIIRANDO TETRAD
	CMP	AL,0AH
	JB	STETR1
	ADD	AL,7
STETR1:	ADD	AL,30H
	MOV	[SI],AL
	RET
;
; ============================
; *** ALFANUMERIKUS CSATOLO
ALFAN:	
; *** KEP KIIRAS ***
	MOV	CX,25	;SOROK SZAMA
	MOV	AL,BYTE PTR CS:AFLAG
	CMP	AL,1
	JB	ALFA0
	MOV	CX,A4_SOR
ALFA0:	MOV	DX,0
ALFA1:	MOV	AX,D_SEG_K
	CALL	ALFIR
	ADD	DX,0A0H	;KOV.SORRA LEPES
	LOOP	ALFA1
	JMP	ZARAS
;
ALFIR:	PUSH	CX
	PUSH	DX
	PUSH	ES
;
	PUSH	DS
	MOV	DS,AX
	CLD
	MOV	SI,DX
	MOV	DI,OFFSET SPUFF
	MOV	AX,CS
	MOV	ES,AX
	MOV	CX,80
ALFI1:	LODSW
	STOSB
	LOOP	ALFI1
	POP	DS
;
	MOV	CX,80
	LEA	SI,SPUFF+79
ALFI2:	MOV	AL,[SI]
	CMP	AL,' '
	JNZ	ALFI3
	DEC	SI
	LOOP	ALFI2
ALFI3:	INC	SI
	MOV	BYTE PTR[SI+0],0DH
	MOV	BYTE PTR[SI+1],0AH
	ADD	CX,2
	LEA	DX,SPUFF
	MOV	AH,FILE_WRITE
	MOV	BX,HANDLE
	INT	UJ_DOS
	POP	ES
	POP	DX
	POP	CX
	RET
;=============================
; *** CGA CSATOLO ****
; ####
; *** KARAKTERES MOD
KARAK:
; *** KEP KIIRAS ***
	MOV	CX,25	;SOROK SZAMA
	MOV	AL,BYTE PTR CS:AFLAG
	CMP	AL,1
	JB	KARAK0
	MOV	CX,A4_SOR
KARAK0:	MOV	DX,0
KARAK1:	MOV	AX,D_SEG_G
	CALL	ALFIR
	ADD	DX,0A0H	;KOV.SORRA LEPES
	LOOP	KARAK1
	JMP	ZARAS
; ####
; *** GRAFIKUS MOD
GRAPH:
; *** VEZETO BLOKK ***
	MOV	SI,200	;RASZTER SOROK SZAMA
	MOV	DI,640	;OSZLOPOK SZAMA
	JMP	CGAXX
;
CGAXX:	MOV	BX,SI	;RASZTER SOROK SZAMA
	MOV	AX,DI
	DEC	BX
	DEC	AX
	MOV	WORD PTR [PCXFEJ+08H],AX	;MAXIMUM X VALUE  (DI - 1)
	MOV	WORD PTR [PCXFEJ+0AH],BX	;MAXIMUM Y VALUE  (SI - 1)
	MOV	WORD PTR [PCXFEJ+0CH],DI	;WIDTH OF PICTURE
	MOV	WORD PTR [PCXFEJ+0EH],SI	;HIGHT OF PICTURE
	MOV	WORD PTR [PCXFEJ+47H],SI	;NUMBER OF LINES OF GR. CARD
	INC	BX
	INC	AX
;
	SHR	AX,1
	SHR	AX,1
	SHR	AX,1
	MOV	WORD PTR [PCXFEJ+42H],AX	;BYTES PER LINE
	MOV	BYTE PTR [PCXFEJ+41H],1		;1 KEPPONT BITJEINEK SZAMA
	MOV	BYTE PTR [PCXFEJ+46H],0
;
	CLD
	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
	MOV	SI,OFFSET RGBCGA
	MOV	DI,OFFSET PCXFEJ+10H
	MOV	CX,30H
	REPZ	MOVSB
;
	MOV	AH,FILE_WRITE
	MOV	BX,HANDLE
	MOV	CX,L_PCX
	LEA	DX,PCXFEJ
	INT	UJ_DOS
	JNC	CXXOK
	JMP	ERROR
CXXOK:
; *** A VALTOZO SOR FRISSITES MIATT SORONKENT 
;     KELL IRNI
	MOV	BX,WORD PTR [PCXFEJ+42H] ; 1 SOR HOSSZA GRAF.MEM-BAN
	MOV	CX,WORD PTR [PCXFEJ+0CH] ; 1 SORBAN KEPPONTOK SZAMA
	SHR	CX,1
	SHR	CX,1
	SHR	CX,1			 ; A SORPUFFER HASZNOS HOSSZA
	MOV	DX,0			 ; KIINDULO SOR SZAMA
	MOV	BP,WORD PTR [PCXFEJ+0EH] ; KEPERNYO SOROK SZAMA
CXXCIKL:
	CALL	CSORIR
	INC	DX
	DEC	BP
	JNZ	CXXCIKL
;
	JMP	ZARAS
;
; ####
; *** HERCULES GRAFIKUS MOD
HERCMOD:
; *** VEZETO BLOKK ***
	CMP	BYTE PTR AFLAG,3
	JB	HERCM1
;
A4GRAF:	MOV	SI,728	;RASZTER SOROK SZAMA
	MOV	DI,720	;OSZLOPOK SZAMA
	JMP	HGAXX
;
HERCM1:	MOV	SI,348	;RASZTER SOROK SZAMA
	MOV	DI,720	;OSZLOPOK SZAMA
	JMP	HGAXX
;
HGAXX:	MOV	BX,SI	;RASZTER SOROK SZAMA
	MOV	AX,DI
	DEC	BX
	DEC	AX
	MOV	WORD PTR [PCXFEJ+08H],AX	;MAXIMUM X VALUE  (DI - 1)
	MOV	WORD PTR [PCXFEJ+0AH],BX	;MAXIMUM Y VALUE  (SI - 1)
	MOV	WORD PTR [PCXFEJ+0CH],DI	;WIDTH OF PICTURE
	MOV	WORD PTR [PCXFEJ+0EH],SI	;HIGHT OF PICTURE
	MOV	WORD PTR [PCXFEJ+47H],SI	;NUMBER OF LINES OF GR. CARD
	INC	BX
	INC	AX
;
	SHR	AX,1
	SHR	AX,1
	SHR	AX,1
	MOV	WORD PTR [PCXFEJ+42H],AX	;BYTES PER LINE
	MOV	BYTE PTR [PCXFEJ+41H],1		;1 KEPPONT BITJEINEK SZAMA
	MOV	BYTE PTR [PCXFEJ+46H],0
;
	CLD
	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
	MOV	SI,OFFSET RGBHGA
	MOV	DI,OFFSET PCXFEJ+10H
	MOV	CX,30H
	REPZ	MOVSB
;
	MOV	AH,FILE_WRITE
	MOV	BX,HANDLE
	MOV	CX,L_PCX
	LEA	DX,PCXFEJ
	INT	UJ_DOS
	JNC	HXXOK
	JMP	ERROR
HXXOK:
; *** A VALTOZO SOR FRISSITES MIATT SORONKENT 
;     KELL IRNI
	MOV	BX,WORD PTR [PCXFEJ+42H] ; 1 SOR HOSSZA GRAF.MEM-BAN
	MOV	CX,WORD PTR [PCXFEJ+0CH] ; 1 SORBAN KEPPONTOK SZAMA
	SHR	CX,1
	SHR	CX,1
	SHR	CX,1			 ; A SORPUFFER HASZNOS HOSSZA
	MOV	DX,0			 ; KIINDULO SOR SZAMA
	MOV	BP,WORD PTR [PCXFEJ+0EH] ; KEPERNYO SOROK SZAMA
HXXCIKL:
	CALL	HSORIR
	INC	DX
	DEC	BP
	JNZ	HXXCIKL
;
	JMP	ZARAS
;
; ####
; *** EGA GRAFIKUS MOD
EGA0D:
	MOV	SI,200	;RASZTER SOROK SZAMA
	MOV	DI,320	;OSZLOPOK SZAMA
	JMP	EGAXX
;
EGA0E:
	MOV	SI,200	;RASZTER SOROK SZAMA
	MOV	DI,640	;OSZLOPOK SZAMA
	JMP	EGAXX
;
EGA0F:
	MOV	SI,350	;RASZTER SOROK SZAMA
	MOV	DI,320	;OSZLOPOK SZAMA
	JMP	EGAXX
;
EGA10:
	MOV	SI,350	;RASZTER SOROK SZAMA
	MOV	DI,640	;OSZLOPOK SZAMA
	JMP	EGAXX
;
EGAXX:	MOV	BX,SI	;RASZTER SOROK SZAMA
	MOV	AX,DI
	DEC	BX
	DEC	AX
	MOV	WORD PTR [PCXFEJ+08H],AX	;MAXIMUM X VALUE  (DI - 1)
	MOV	WORD PTR [PCXFEJ+0AH],BX	;MAXIMUM Y VALUE  (SI - 1)
	MOV	WORD PTR [PCXFEJ+0CH],DI	;WIDTH OF PICTURE
	MOV	WORD PTR [PCXFEJ+0EH],SI	;HIGHT OF PICTURE
	MOV	WORD PTR [PCXFEJ+47H],SI	;NUMBER OF LINES OF GR. CARD
	INC	BX
	INC	AX
;
	SHR	AX,1
	SHR	AX,1
	SHR	AX,1
	MOV	WORD PTR [PCXFEJ+42H],AX	;BYTES PER LINE
	MOV	BYTE PTR [PCXFEJ+41H],4		;1 KEPPONT BITJEINEK SZAMA
	MOV	BYTE PTR [PCXFEJ+46H],0
;
	CLD
	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
	MOV	SI,OFFSET RGBEGA
	MOV	DI,OFFSET PCXFEJ+10H
	MOV	CX,30H
	REPZ	MOVSB
;
	MOV	AH,FILE_WRITE
	MOV	BX,HANDLE
	MOV	CX,L_PCX
	LEA	DX,PCXFEJ
	INT	UJ_DOS
	JNC	EXXOK
	JMP	ERROR
EXXOK:
; *** A VALTOZO SOR FRISSITES MIATT SORONKENT 
;     KELL IRNI
	MOV	BX,WORD PTR [PCXFEJ+42H] ; 1 SOR HOSSZA GRAF.MEM-BAN
	MOV	CX,WORD PTR [PCXFEJ+0CH] ; 1 SORBAN KEPPONTOK SZAMA
	SAR	CX,1			 ; A SORPUFFER HASZNOS HOSSZA
	MOV	DX,0			 ; KIINDULO SOR SZAMA
	MOV	BP,WORD PTR [PCXFEJ+0EH] ; KEPERNYO SOROK SZAMA
EXXCIKL:
	CALL	ESORIR
	INC	DX
	DEC	BP
	JNZ	EXXCIKL
;
	JMP	ZARAS
;
; BE : DX = CGA SOR SZAMA
;    : CX = CGA SORPUFFER HASZNOS HOSSZA
;    : BX = 1 SOR HOSSZA A DISPLAY MEMORIABAN
;
CSORIR:	PUSH	BX		; 1 SOR HOSSZA DISPLAY MEM-BAN
	PUSH	CX		; CGA SORPUFFER HASZNOS HOSSZA
	PUSH	DX		; CGA SOR SZAMA
	PUSH	BP		; CIKLUSSZAMLALO
	CALL	CgaRowRead	; 1 CGA SOR BEOLVASASA
	CALL	FileRowWrite
	POP	BP
	POP	DX
	POP	CX
	POP	BX
	RET
;
; BE : DX = HGA SOR SZAMA
;    : CX = HGA SORPUFFER HASZNOS HOSSZA
;    : BX = 1 SOR HOSSZA A DISPLAY MEMORIABAN
;
HSORIR:	PUSH	BX		; 1 SOR HOSSZA DISPLAY MEM-BAN
	PUSH	CX		; HGA SORPUFFER HASZNOS HOSSZA
	PUSH	DX		; HGA SOR SZAMA
	PUSH	BP		; CIKLUSSZAMLALO
	MOV	AL,CS:AFLAG	; 3 => A4-ES MENTES
	CALL	Hga_A4_RowRead	; 1 HGA SOR BEOLVASASA
	CALL	FileRowWrite
	POP	BP
	POP	DX
	POP	CX
	POP	BX
	RET
;
; BE : DX = EGA SOR SZAMA
;    : CX = EGA SORPUFFER HASZNOS HOSSZA
;    : BX = 1 SOR HOSSZA A DISPLAY MEMORIABAN
;
ESORIR:	PUSH	BX		; 1 SOR HOSSZA DISPLAY MEM-BAN
	PUSH	CX		; EGA SORPUFFER HASZNOS HOSSZA
	PUSH	DX		; EGA SOR SZAMA
	PUSH	BP		; CIKLUSSZAMLALO
	CALL	EgaRowRead	; 1 EGA SOR BEOLVASASA
	CALL	FileRowWrite
	POP	BP
	POP	DX
	POP	CX
	POP	BX
	RET
;
FileRowWrite:
	CLI
	MOV	SI,OFFSET RowPuf ;input  puffer
	MOV	DI,OFFSET SEGED  ;output puffer
	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
;
FR1:	LODSB			;1.KAR. FELDOLGOZASA
	MOV	BL,AL
	MOV	BH,1		;ISMETLESEK SZAMA
	JMP	SHORT FR4
FR2:	LODSB
	CMP	AL,BL		;EGYEZO KARAKTER ?
	JNE	FR3		;HA NEM, AKKOR URITES
	INC	BH
	CMP	BH,0ffh-maxkar
	JNA	FR4		; < MAXKAR EGYEZO KARAKTER
	DEC	BH
FR3:	CALL	ESTAR
FR4:	LOOP	FR2
	CALL	ESTAR
;
	MOV	DX,OFFSET SEGED
	MOV	CX,DI
	SUB	CX,DX
	MOV	AH,FILE_WRITE
	MOV	BX,cs:HANDLE
	INT	UJ_DOS
	RET
;
ESTAR:	MOV	AH,AL	;uj karakter mentese
	CLI
	CMP	BH,1
	ja	est1	;ismetlodo karakter
	cmp	bl,maxkar
	ja	est1
EST0:	MOV	AL,BL	;nem ismetlodo, es a karakter  <= 0c0h
	STOSB
	JMP	SHORT EST2
EST1:	MOV	AL,BH	;2 byte kikuldes
	ADD	AL,maxkar
	STOSB		;karakter ismetlodes hossza + maxkar
	MOV	AL,BL
	STOSB		;ismetlodo karakter
EST2:	MOV	BH,1
	MOV	BL,AH
	RET
;
GETMOD:	PUSH	DS	;hercules kartya alfa/grafikus
	PUSH	ES	;uzemmod lekerdezese
	PUSH	SI
	PUSH	DI
	MOV	AX,CS:HERC
	OR	AX,AX
	JNZ	L00
	JMP	L10	;NINCS HERCULES KARTYA
L00:	MOV	DX,3BBH
	OUT	DX,AL
	DEC	DX
L01:	IN	AL,DX
	TEST	AL,80H
	JNZ	L01
L02:	IN	AL,DX
	TEST	AL,80H
	JZ	L02
	CLI
L03:	IN	AL,DX
	TEST	AL,80H
	JNZ	L03
;
	DEC	DX
	OUT	DX,AL
	STI
	MOV	DL,0B4H
;
	MOV	AL,0EH
	OUT	DX,AL
	INC	DX
	IN	AL,DX	;CURSOR position high REGISTER
	DEC	DX
	MOV	AH,AL
	MOV	AL,0FH
	OUT	DX,AL
	INC	DX
	IN	AL,DX	;CURSOR position  low  REGISTER
	DEC	DX
	MOV	BX,AX
;
	MOV	DL,0B4H
	MOV	AL,10H
	OUT	DX,AL
	INC	DX
	IN	AL,DX	;LIGHT PEN high REGISTER
	DEC	DX
	MOV	AH,AL
	MOV	AL,11H
	OUT	DX,AL
	INC	DX
	IN	AL,DX	;LIGHT PEN low  REGISTER
	DEC	DX
	MOV	DX,BX
	CMP	BYTE PTR AFLAG,1
	JB	L06		;NORMAL HERCULES KARTYA
	MOV	AL,BYTE PTR AFLAG
	CMP	AL,1
	JZ	L08		;A4 TEXT MOD
	JMP	SHORT L09	;A4 FULL/HERCULES MOD
L06:	CMP	AX,0F4BH
	JGE	L07	;GRAPH.MOD
	MOV	AX,0	;TEXT  MOD  -  [07d0,0f4b)
	JMP	SHORT L10
L07:	MOV	AH,0FH
	INT	10H	;VIDEO LAP LEKERDEZES
	MOV	AL,BH
	SUB	AH,AH
	INC	AX
	JMP	SHORT L10
L08:	MOV	AX,0
	JMP	SHORT L10
L09:	MOV	AX,1
L10:	POP	DI
	POP	SI
	POP	ES
	POP	DS
	RET
;
;************************************ 
;                                   *
;     Hercules/A4 sor olvasasa      *
;                                   * 
; BE : DX = HGA SOR SZAMA (0 - 727) *
;    : BX = 1 SOR HOSSZ DISPLAY     *
;                       MEMORIABAN  *         
;                                   *
;************************************
;
Hga_A4_RowRead PROC NEAR
	PUSH	DS
	PUSH	ES
	PUSH	CX
	PUSH	DX	;SOR SZAMA  (0-347 / 0-727)
	MOV	SI,WORD PTR CS:H_BASE
	CMP	AL,3
	JB	HgaRd0	;HARCULES/A4 HERCULES MODBAN
	MOV	SI,H_SCR0
	CMP	DX,A4GSOR/2
	JB	HgaRd0
	MOV	SI,H_SCR1
	SUB	DX,A4GSOR/2
HgaRd0:	CLD
	MOV	BP,BX	;SOR HOSSZA BYTE-BAN (90)
	MOV	AX,0003H 
	AND	AX,DX 
	MOV	CL,9 
	SHL	AX,CL
	ADD	AX,SI 
	MOV	DS,AX	;HGA SZEGMENS
	MOV	AX,DX
	MOV	CL,2
	SHR	AX,CL
	MUL	BP
	MOV	SI,AX	;HGA OFFSET
;
	MOV	AX,CS
	MOV	ES,AX
	MOV	DI,OFFSET RowPuf
	MOV	CX,BP
	REP	MOVSB
	POP	DX
	POP	CX
	POP	ES
	POP	DS
	RET
Hga_A4_RowRead ENDP
;
	PAGE
;
;************************************ 
;                                   *
;         Cga sor olvasasa          *
;                                   * 
; BE : DX = CGA SOR SZAMA (0 - 199) *
;    : BX = 1 SOR HOSSZ DISPLAY     *
;                       MEMORIABAN  *         
;                                   *
;************************************
;
CgaRowRead PROC NEAR
	PUSH	DS
	PUSH	ES
	PUSH	CX
	PUSH	DX	;SOR SZAMA  (0 - 199)
	CLD
	MOV	BP,BX	;SOR HOSSZA BYTE-BAN (80)
	MOV	AX,0001H 
	AND	AX,DX 
	MOV	CL,9 
	SHL	AX,CL
	ADD	AX,C_SEG1
	MOV	DS,AX	;CGA SZEGMENS
	MOV	AX,DX
	MOV	CL,1
	SHR	AX,CL
	MUL	BP
	MOV	SI,AX	;CGA OFFSET
;
	MOV	AX,CS
	MOV	ES,AX
	MOV	DI,OFFSET RowPuf
	MOV	CX,BP
	REP	MOVSB
	POP	DX
	POP	CX
	POP	ES
	POP	DS
	RET
CgaRowRead ENDP
;
	PAGE
;
COL	EQU	50H	;EGYENLORE
EGABASE	EQU	0A000H
EGAPORT	EQU	3CEH
REG04	EQU	04
REG05	EQU	05	;EGA MOD BIT

; Ega controll registers

;0 - set/reset
;1 - enable set/reset
;2 - color compare
;3 - data rotate
;4 - read map select
;5 - mode /bit(3):read mode, bit(1-0) :write mode/
;6 - depends on video mode
;7 - 0f : color 16
;    01 : color 2
;8 - bit mask
;

;************************************ 
;                                   *
;         Ega sor olvasasa          *
;                                   * 
; BE : DX = EGA SOR SZAMA (0 - 349) *
;    : BX = 1 SOR HOSSZ DISPLAY     *
;                       MEMORIABAN  *         
;                                   *
;************************************
;
EgaRowRead PROC NEAR
	PUSH	DS
	PUSH	ES
	PUSH	CX
	PUSH	DX
	CLD
	MOV	AX,DX	;SOR SZAMA  (0 - 349)
	MOV	BP,BX	;SOR HOSSZA BYTE-BAN (80)
	MUL	BX
	MOV	SI,AX
	MOV	AX,EGABASE
	MOV	DS,AX
;
	MOV	DI,OFFSET RowPuf
	MOV	AX,CS
	MOV	ES,AX	;CELPUFFER
;
	MOV	DX,EGAPORT
	MOV	AX,0005H
	OUT	DX,AX	;0 READ MOD, 0 WRITE MOD
RCIK1:	MOV	AX,0304H ;READ MAP SELECT
	OUT	DX,AX
	MOV	CH,[SI]	;3.PLANE
	DEC	AH
	OUT	DX,AX
	MOV	CL,[SI]	;2.PLANE
	DEC	AH
	OUT	DX,AX
	MOV	BH,[SI]	;1.PLANE
	DEC	AH
	OUT	DX,AX
	MOV	BL,[SI]	;0.PLANE
	MOV	AH,4	;BITEK SZAMA
RCIK2:	XOR	AL,AL
	ROL	CH,1	;3.PLANE
	RCL	AL,1
	ROL	CL,1	;2.PLANE
	RCL	AL,1
	ROL	BH,1	;1.PLANE
	RCL	AL,1
	ROL	BL,1	;0.PLANE
	RCL	AL,1
	ROL	CH,1	;3.PLANE
	RCL	AL,1
	ROL	CL,1	;2.PLANE
	RCL	AL,1
	ROL	BH,1	;1.PLANE
	RCL	AL,1
	ROL	BL,1	;0.PLANE
	RCL	AL,1
	STOSB
	DEC	AH
	JNZ	RCIK2	;KOV.KEPPONT
;
	INC	SI
	DEC	BP
	JNZ	RCIK1
;
	POP	DX
	POP	CX
	POP	ES
	POP	DS
	RET
EgaRowRead ENDP
;
; BE: AX = KIIRANDO SOR SZAMA
;
EgaRowWrite PROC NEAR
	PUSH	DS
	PUSH	ES
	PUSH	SI
	PUSH	DI
	CLD
	MOV	CX,COL
	MUL	CX
	MOV	SI,AX
	MOV	AX,EGABASE
	MOV	DS,AX
;
	MOV	DI,OFFSET RowPuf
	MOV	AX,CS
	MOV	ES,AX	;CELPUFFER
;
	MOV	DX,EGAPORT
	MOV	AX,0005H
	OUT	DX,AX	;0 READ MOD, 0 WRITE MOD
	PUSH	BP
	MOV	BP,COL
	MOV	AX,1803H
	OUT	DX,AX
WCIK1:	MOV	CH,80H
	MOV	CL,4	;BITEK SZAMA
WCIK2:	MOV	BL,BYTE PTR ES:[DI]
	MOV	AL,8
	MOV	AH,CH	;BIT MASZK
	OUT	DX,AX
	MOV	AH,BL
	ROR	AH,1
	ROR	AH,1
	ROR	AH,1
	ROR	AH,1
	AND	AH,0FH
	MOV	AL,0
	OUT	DX,AX	
	MOV	AX,0F01H
	OUT	DX,AX
	OR	DS:[SI],AL
	ROR	CH,1	
;
	MOV	AL,8
	MOV	AH,CH	;BIT MASZK
	OUT	DX,AX
	MOV	AL,0
	MOV	AH,BL
	AND	AH,0FH
	OUT	DX,AX
	MOV	AX,0F01H
	OUT	DX,AX
	OR	DS:[SI],AL
	ROR	CH,1	
	INC	DI
	DEC	CL
	JNZ	WCIK2
;
	INC	SI
	DEC	BP
	JNZ	WCIK1
;
	MOV	AX,0FF08H	;DEFAULT BIT MASK
	OUT	DX,AX
;
	MOV	AX,0005H	;DEFAULT MODE REGISTER
	OUT	DX,AX
;
	MOV	AX,0003H	;DEFAULT FUNCTION SELECT
	OUT	DX,AX
;
	MOV	AX,0001H	;DEFAULT ENABLE SET/RESET
	OUT	DX,AX
;
	POP	BP
	POP	DI
	POP	SI
	POP	ES
	POP	DS
	RET
EgaRowWrite ENDP
;
PROG_VEG EQU	$
;
TXKILL	LABEL	BYTE
	DB	0DH,0AH
	DB	'PCXSAVE has been killed'
	DB	0DH,0AH
	DB	'$'
;
TXRES	LABEL	BYTE
	DB	0DH,0AH
	DB	'PCXSAVE already resident !!!'
	DB	'$'
;
TXPAR:	DB	0DH,0AH
	DB	0DH,0AH
	DB	'PCXSAVE version 1.0 - VIDEOTON SGYL 1989.03.29'
	DB	0DH,0AH
	DB	0DH,0AH
	DB	'Usage: PCXSAVE [0/1/2/3][N/C][K] (implicit:0C)'
	DB	0DH,0AH
	DB	'Where  0 - Display type is HERCULES/CGA/EGA'
	DB	0DH,0AH
	DB	'       1 - Display type is A4 - ascii save'
	DB	0DH,0AH
	DB	'       2 - Display type is A4 - hercules graph. save'
	DB	0DH,0AH
	DB	'       3 - Display type is A4 - full graph. save'
	DB	0DH,0AH
	DB	'       N - Txtsav.txt   file create'
	DB	0DH,0AH
	DB	'         - Pcxsav00.pcx file create'
	DB	0DH,0AH
	DB	'       C - Txtsav.txt   file continue'
	DB	0DH,0AH
	DB	'         - Pcxsavxx.pcx file create (xx hexa : 00 - ff)'
	DB	0DH,0AH
	DB	'       K - Program kill'
	DB	0DH,0AH
	DB	'Press <PrtSc> key to save screen '
	DB	0DH,0AH
	DB	'File name will be :\TXTSAV.TXT   (in case of ascii save)'
	DB	0DH,0AH
	DB	'                  :\PCXSAVXX.PCX (in case of graph.save)'
	DB	0DH,0AH
	DB	'Parameters are :$'
;
TXCRLF	LABEL	BYTE
	DB	0DH,0AH
	DB	'$'
;
TXNRES	LABEL	BYTE
	DB	0DH,0AH
	DB	'PCXSAVE has been activated !!!'
	DB	'$'
;
STARTX:	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
;
	MOV	AX,WORD PTR RESI
	OR	AX,AX
	JNZ	START1	;REZIDENS ESET
;
START0:	CALL	HPRES	;NEM REZIDENS ESET
	MOV	WORD PTR HERC,AX
;
	CALL	PARBE
	CALL	FORUTIN
	INT	20H
;	
START1:	CALL	HPRES	;REZIDENS PROGRAMKENT TOLTES
	MOV	WORD PTR HERC,AX
;
	MOV	AH,ITC_OLVAS
	MOV	AL,PR_SC_INT
	INT	DOS_HIV
	MOV	PSC_MENT_O,BX	; ELTOLAS MENTESE
	MOV	BX,ES
	MOV	PSC_MENT_S,BX	; SEGMENS MENTESE
; *** ellenorizzuk hogy eloszor toltenek
	mov	bx,psc_ment_s
	mov	es,bx
	mov	bx,psc_ment_o
	cmp	word ptr es:[bx-2],'Vx'
	jnz	ELSO
	MOV	AX,PSC_MENT_S
	MOV	ES,AX
	CALL	PARBE
	JZ	NOKILL
	CALL	KILL
	MOV	AH,9
	LEA	DX,TXKILL
	INT	DOS_HIV
	INT	20H
NOKILL:	MOV	AH,9
	LEA	DX,TXRES
	INT	DOS_HIV
	MOV	AH,9
	LEA	DX,TXPAR
	INT	DOS_HIV
	MOV	AX,PSC_MENT_S
	MOV	ES,AX
	CALL	PARIR
	INT	20H
ELSO:
; *** PRTSC IT ATIRASA A MI CIMUNKRE
	MOV	AX,CS
	MOV	DS,AX
	MOV	ES,AX
	CALL	PARBE
	JZ	OKE
	MOV	AH,9
	LEA	DX,TXKILL
	INT	DOS_HIV
	INT	20H
OKE:	MOV	AH,ITC_IR
	MOV	AL,PR_SC_INT
	LEA	DX,BEGIN
; DS=CS MIVEL COM PROGRAMOT IRTUNK
	INT	DOS_HIV
	MOV	AH,9
	LEA	DX,TXNRES
	INT	DOS_HIV
	MOV	AH,9
	LEA	DX,TXPAR
	INT	DOS_HIV
	CALL	PARIR
	MOV	AH,REZIDENS
	MOV	AL,0		; KILEPES KOD , MINDEN O.K.
	MOV	CL,4		
	LEA	DX,PROG_VEG
	SHR	DX,CL		; PROGRAM MERET PARAGRAFUSBAN
	INC	DX	 	; +PARAGRAFUS A MARADEKNAK
	INT	uj_dos
;
;####### VEGUNK VAN !!!! #################
DISALL	EQU	03BAH
KONFIG	EQU	03BEH
KBYTE	EQU	03H	;01H IF ONLY TEXT/GRAF.MODE
; 
HPRES	PROC	NEAR
	PUSH	DS
	PUSH	ES
	MOV	BX,0100H	;KULSO CIKLUS SZAMLALO 
	MOV	DX,DISALL 
	IN	AL,DX 
	MOV	AH,AL 
	AND	AH,80H 
L100C:	MOV	CX,0040H 
L100F:	IN	AL,DX 
	AND	AL,80H 
	CMP	AL,AH 
	LOOPZ	L100F 
	JNE	L101D 
	DEC	BX 
	JNE	L100C 
	JMP	SHORT L1050	;AL=0 
L101D:	MOV	AX,0B000H 
	MOV	ES,AX 
	CALL	L1036 
	JNE	L1032 
	MOV	AL,KBYTE 
	MOV	DX,KONFIG 
	OUT	DX,AL 
	CALL	L1036 
	JE	L1050		;AL=0 
L1032:	MOV	AL,01H 
	JMP	SHORT L1052 
; 
L1036	PROC	NEAR 
	MOV	BL,ES:[7FFFH] 
	MOV	CL,ES:[3FFFH] 
	INC	BYTE PTR ES:[3FFFH] 
	CMP	BL,ES:[3FFFH] 
	MOV	ES:[3FFFH],CL 
	RET   
L1036	ENDP 
; 
L1050:	XOR	AL,AL 
L1052:	XOR	AH,AH 
	OR	AX,AX 
	JZ	L1057 
	INT	11H		;CONFIGURACIO LEKERDEZES 
	AND	AX,30H 
	CMP	AX,30H 
	MOV	AX,1 
	JZ	L1057 
	XOR	AX,AX 
L1057:
	POP	ES
	POP	DS
	RET
HPRES	ENDP
; 
PARBE:	MOV	AX,CS
	MOV	DS,AX
	MOV	SI,81H
	CLD
PARB1:	LODSB		;KEZDO SZOKOZOK VAGASA
	CMP	AL,' '
	JZ	PARB1
	CMP	AL,09
	JZ	PARB1
;
PARB2:	CMP	AL,0DH
	JNZ	PARB3	;VAN PARAMETER
	MOV	AL,BYTE PTR ES:KFLAG
	OR	AL,AL
	RET
PARB3:
	CALL	KICSI
;
	MOV	DI,OFFSET AFLAG	;HERCULES/A4 TEXT/A4 GRAPH. KARTYA
	MOV	AH,0		;NORMAL HERCULES KARTYA
	CMP	AL,'0'
	JZ	JOPAR
	MOV	AH,1		;A4-ES HERCULESKENT KEZELVE
	CMP	AL,'1'
	JZ	JOPAR
	MOV	AH,2		;A4 TEXT
	CMP	AL,'2'
	JZ	JOPAR
	MOV	AH,3		;A4 GRAPH.
	CMP	AL,'3'
	JZ	JOPAR
;
	MOV	DI,OFFSET CFLAG	;FOLYTATAS
	CMP	AL,'C'
	JZ	JOPAR
;
	MOV	DI,OFFSET KFLAG	;KILL
	CMP	AL,'K'
	JZ	JOPAR
;
	MOV	AH,0
	MOV	DI,OFFSET CFLAG	;FOLYTATAS
	CMP	AL,'N'
	JNZ	PARB4
JOPAR:	MOV	BYTE PTR ES:[DI],AH
PARB4:	LODSB
	JMP	SHORT PARB2
;
KICSI:	CMP	AL,60H
	JB	KICSX
	CMP	AL,7BH
	JNB	KICSX
	SUB	AL,20H
KICSX:	OR	AL,AL
	RET
;
PARIR:	MOV	AL,ES:AFLAG
	OR	AL,30H
PARI1:	MOV	AH,0EH
	INT	10H
	MOV	AL,ES:CFLAG
	OR	AL,AL
	MOV	AL,'C'
	JNZ	PARI2
	MOV	AL,'N'
PARI2:	MOV	AH,0EH
	INT	10H
	LEA	DX,TXCRLF
	MOV	AH,9
	INT	DOS_HIV
	RET
;
KILL:	MOV	DX,WORD PTR CS:(PSC_MENT_S)
	PUSH	ES
	PUSH	DS
	PUSH	DX
	MOV	ES,DX		;REZ.PROGRAM szegmenscim
	MOV	AH,49H		;MEMORIA FELSZABADITAS
	INT	DOS_HIV
	POP	ES
;
	CLI
	MOV	CX,WORD PTR ES:(PSC_MENT_O)	;EREDETI INT VISSZA
	MOV	DX,WORD PTR ES:(PSC_MENT_S)
	MOV	AX,0
	MOV	DS,AX
	MOV	WORD PTR DS:(4*PR_SC_INT),CX
	MOV	WORD PTR DS:(4*PR_SC_INT+2),DX
	STI
;
	MOV	BX,2CH			;ENVIROMENT SZEGMENS CIM
	MOV	DX,WORD PTR ES:[BX]
	MOV	ES,DX	;szegmenscim
	MOV	AH,49H	;MEMORIA FELSZABADITAS
	INT	DOS_HIV
	POP	DS
	POP	ES
	RET
;
CSEG	ENDS
	END	START
